
function EditList(){
   /*
   Class to manage configuration lists window
   */
   this.list="";
   this.filename="";
   this.listspath='/etc/lliurex-guard-standalone/config/lists/';
}

// Methods

EditList.prototype.validateKey = function validateKey(key){
   if ((key<=57&&key>=48)|| (key<=122&&key>=97) || (key<=90&&key>=65) || key===13 || key == 46) {
	  return true;
   } else return false;
   
}


EditList.prototype.setListContent = function setListContent(filename, list){
   var self=this;
   self.filename=filename;
   self.list=list;
}

EditList.prototype.compareContent = function compareContent(list){
   var self=this;
   return (list===self.list);
}


EditList.prototype.saveFile = function saveFile(list){
   
   //alert("***"+list+" is "+typeof(list));
   
   var self=this;
   
   //self.filename, self.list
   //console.log(localStorage.server);
   //alert(localStorage.server);
   // Save File via N4D
	  $.xmlrpc({
		 url: 'https://'+localStorage.server+':9779',
		 methodName: 'set_list_file',
		 params: [[localStorage.username, localStorage.password], "N4dGuard", self.filename, list ],
		 success: function(response,status,jqXHR){
			if (response[0]!=true) {
			   alert("Error: "+response[0]);
			} else {
			   $("#infotext").html(i18n.gettext("file.saved"));
			   $("#infotext").addClass("shown");
			}
		 	console.log(response[0]);
		
			
		},
		error: function(jqXHR, status, error) {
			alert("Status: "+status+"\nError: N4D server is down "+error);
		}
	  })   
}

EditList.prototype.showhelp = function showhelp(){
	$("#help_title").empty();
	$("#help_text").empty();
	
	var title=i18n.gettext("dst.domains.help.title");
	var  content=i18n.gettext("dst.domains.help.content");
	
	$("#help_list_format_title").html(title);
	$("#help_list_format_text").html(content);
	
	$("#modal_list").show();
	$("#help_list_format").show();
	
		
}


EditList.prototype.bindEventHandlers = function bindEventHandlers(){
   var self=this;
   
   $('#text_list').keypress(function(e){
	  $("#infotext").removeClass("shown");
	  return self.validateKey(e.which);
    
   });
   
   
   $("#btsavelist").bind("click", function(){
	  self.list=$("#text_list").val();
	  self.saveFile(self.list);
	  
   });
   
   $("#btcanceledit").bind("click", function(){
	  var gui = require('nw.gui');
		 
	  // if contents has not been modified let's close the window
	  if(self.compareContent($("#text_list").val()))
		 gui.Window.get().close();
	  else {
		 var r = confirm(i18n.gettext("close.no.saving"));
		 if (r == true) gui.Window.get().close();
		 }
   
   });
   
   $("#bthelp").bind("click", function(){
	  self.showhelp();
   })
   
   $("#btclosehelp").bind("click", function(){
	  $("#modal_list").hide();
	  $("#help_list_format").hide();
   })
} // end bind event handlers



    
// Methods
$(document).ready(function() {
   var fs = require('fs');
   
   list=JSON.parse(localStorage.getItem("edit_list"));
   
   $("#list_title").html(list["file"]);
   // Read File
   var filename=list["filepath"];   
   // Check if list file exists...
   try{
	  if(fs.statSync(filename).isFile()) {
	    file_content=(fs.readFileSync(filename)).toString();		
	  }
   } catch (err){ // if file does not exists, its content will be null
	  file_content="";
   }
   
   $("#text_list").val(file_content);
   
   listEditor=new EditList();
   
   //listEditor.setListContent(list["file"],list["list"]);
   listEditor.setListContent(list["file"],file_content);
   
   listEditor.bindEventHandlers();
   
   // Force save if is a new file
   if (localStorage.force_initial_save==="true") {
	  listEditor.saveFile("");	
   }
   
   
})